let imports = {};
imports['__wbindgen_placeholder__'] = module.exports;
let wasm;
const { TextDecoder } = require(String.raw`util`);

let cachedTextDecoder = new TextDecoder('utf-8', { ignoreBOM: true, fatal: true });

cachedTextDecoder.decode();

let cachegetUint8Memory0 = null;
function getUint8Memory0() {
    if (cachegetUint8Memory0 === null || cachegetUint8Memory0.buffer !== wasm.memory.buffer) {
        cachegetUint8Memory0 = new Uint8Array(wasm.memory.buffer);
    }
    return cachegetUint8Memory0;
}

function getStringFromWasm0(ptr, len) {
    return cachedTextDecoder.decode(getUint8Memory0().subarray(ptr, ptr + len));
}

const heap = new Array(32).fill(undefined);

heap.push(undefined, null, true, false);

let heap_next = heap.length;

function addHeapObject(obj) {
    if (heap_next === heap.length) heap.push(heap.length + 1);
    const idx = heap_next;
    heap_next = heap[idx];

    heap[idx] = obj;
    return idx;
}

function getObject(idx) { return heap[idx]; }

function dropObject(idx) {
    if (idx < 36) return;
    heap[idx] = heap_next;
    heap_next = idx;
}

function takeObject(idx) {
    const ret = getObject(idx);
    dropObject(idx);
    return ret;
}

let WASM_VECTOR_LEN = 0;

let cachegetNodeBufferMemory0 = null;
function getNodeBufferMemory0() {
    if (cachegetNodeBufferMemory0 === null || cachegetNodeBufferMemory0.buffer !== wasm.memory.buffer) {
        cachegetNodeBufferMemory0 = Buffer.from(wasm.memory.buffer);
    }
    return cachegetNodeBufferMemory0;
}

function passStringToWasm0(arg, malloc) {

    const len = Buffer.byteLength(arg);
    const ptr = malloc(len);
    getNodeBufferMemory0().write(arg, ptr, len);
    WASM_VECTOR_LEN = len;
    return ptr;
}

function _assertClass(instance, klass) {
    if (!(instance instanceof klass)) {
        throw new Error(`expected instance of ${klass.name}`);
    }
    return instance.ptr;
}

let cachegetInt32Memory0 = null;
function getInt32Memory0() {
    if (cachegetInt32Memory0 === null || cachegetInt32Memory0.buffer !== wasm.memory.buffer) {
        cachegetInt32Memory0 = new Int32Array(wasm.memory.buffer);
    }
    return cachegetInt32Memory0;
}
/**
*/
class Context {

    static __wrap(ptr) {
        const obj = Object.create(Context.prototype);
        obj.ptr = ptr;

        return obj;
    }

    free() {
        const ptr = this.ptr;
        this.ptr = 0;

        wasm.__wbg_context_free(ptr);
    }
    /**
    */
    constructor() {
        var ret = wasm.context_new();
        return Context.__wrap(ret);
    }
    /**
    * @param {Date} date
    */
    setTime(date) {
        wasm.context_setTime(this.ptr, addHeapObject(date));
    }
    /**
    * @param {string} live_defs
    */
    loadCurrency(live_defs) {
        var ptr0 = passStringToWasm0(live_defs, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        var len0 = WASM_VECTOR_LEN;
        wasm.context_loadCurrency(this.ptr, ptr0, len0);
    }
    /**
    * @param {Query} expr
    * @returns {any}
    */
    eval(expr) {
        _assertClass(expr, Query);
        var ret = wasm.context_eval(this.ptr, expr.ptr);
        return takeObject(ret);
    }
}
module.exports.Context = Context;
/**
*/
class Query {

    static __wrap(ptr) {
        const obj = Object.create(Query.prototype);
        obj.ptr = ptr;

        return obj;
    }

    free() {
        const ptr = this.ptr;
        this.ptr = 0;

        wasm.__wbg_query_free(ptr);
    }
    /**
    * @param {string} input
    */
    constructor(input) {
        var ptr0 = passStringToWasm0(input, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        var len0 = WASM_VECTOR_LEN;
        var ret = wasm.query_new(ptr0, len0);
        return Query.__wrap(ret);
    }
    /**
    * @returns {any}
    */
    getExpr() {
        var ret = wasm.query_getExpr(this.ptr);
        return takeObject(ret);
    }
}
module.exports.Query = Query;

module.exports.__wbindgen_json_parse = function(arg0, arg1) {
    var ret = JSON.parse(getStringFromWasm0(arg0, arg1));
    return addHeapObject(ret);
};

module.exports.__wbindgen_string_new = function(arg0, arg1) {
    var ret = getStringFromWasm0(arg0, arg1);
    return addHeapObject(ret);
};

module.exports.__wbindgen_object_drop_ref = function(arg0) {
    takeObject(arg0);
};

module.exports.__wbg_new_59cb74e423758ede = function() {
    var ret = new Error();
    return addHeapObject(ret);
};

module.exports.__wbg_stack_558ba5917b466edd = function(arg0, arg1) {
    var ret = getObject(arg1).stack;
    var ptr0 = passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    var len0 = WASM_VECTOR_LEN;
    getInt32Memory0()[arg0 / 4 + 1] = len0;
    getInt32Memory0()[arg0 / 4 + 0] = ptr0;
};

module.exports.__wbg_error_4bb6c2a97407129a = function(arg0, arg1) {
    try {
        console.error(getStringFromWasm0(arg0, arg1));
    } finally {
        wasm.__wbindgen_free(arg0, arg1);
    }
};

module.exports.__wbg_getUTCDate_0a9953d69977794e = function(arg0) {
    var ret = getObject(arg0).getUTCDate();
    return ret;
};

module.exports.__wbg_getUTCFullYear_17e9f44f38059e1f = function(arg0) {
    var ret = getObject(arg0).getUTCFullYear();
    return ret;
};

module.exports.__wbg_getUTCHours_1ca651caf4bee256 = function(arg0) {
    var ret = getObject(arg0).getUTCHours();
    return ret;
};

module.exports.__wbg_getUTCMilliseconds_78072cdb59164839 = function(arg0) {
    var ret = getObject(arg0).getUTCMilliseconds();
    return ret;
};

module.exports.__wbg_getUTCMinutes_a18a53f58efc1754 = function(arg0) {
    var ret = getObject(arg0).getUTCMinutes();
    return ret;
};

module.exports.__wbg_getUTCMonth_773ef20b9a86310b = function(arg0) {
    var ret = getObject(arg0).getUTCMonth();
    return ret;
};

module.exports.__wbg_getUTCSeconds_6f22bb4907492585 = function(arg0) {
    var ret = getObject(arg0).getUTCSeconds();
    return ret;
};

module.exports.__wbindgen_throw = function(arg0, arg1) {
    throw new Error(getStringFromWasm0(arg0, arg1));
};

module.exports.__wbindgen_rethrow = function(arg0) {
    throw takeObject(arg0);
};

const path = require('path').join(__dirname, 'rink_js_bg.wasm');
const bytes = require('fs').readFileSync(path);

const wasmModule = new WebAssembly.Module(bytes);
const wasmInstance = new WebAssembly.Instance(wasmModule, imports);
wasm = wasmInstance.exports;
module.exports.__wasm = wasm;

